# shuffle.awk
#
# Thu Feb 21 10:05:28  2002
# 
# shuffles all lines in a given file according to random seed SRAND.
# if -vSRAND=0 is passed or omitted, srand() is used.
# 
# Requires much of memory for storing the given data file and the 
# shuffle list indices.
#
# Example:
#   awk -vSRAND=123 -
#   shuffles the standard input (after closing the channel).

{
  shuffle[NR] = NR + 0.
  data[NR] = $0
}

END {

  if(SRAND > 0)
    srand(SRAND)
  else
    srand()

  shuffle_index = NR + 1
  
  if(N <= 0) N = NR

  for(n = 1; n <= N; n++) {
    
    if(shuffle_index > NR) { 
    
      for(shuffle_index = 1; shuffle_index <= NR; shuffle_index++) {
        z = int(rand()*NR) + 1
        i = shuffle[shuffle_index]
        shuffle[shuffle_index] = shuffle[z]
        shuffle[z] = i
      }
      shuffle_index = 1
    }
    
    ind = shuffle[shuffle_index++]

    print data[ind]
  }
}


